#include "bitmap.h"
#include "math.h"

int main(int argc,char * argv[]){
  if (argc<=2 || argc>=5){
    printf("Usage: edge fileIn fileOut [treshold]\n");
  }else{
    Bitmap<int> bIn,bOut;
    float f=24;
    Bitmap<int>::RGB dx,dy;
    int i,j;
    if (argc==4)
      f=atof(argv[3]);
    bIn.loadFile(argv[1]);
    bOut.setWidth(bIn.getWidth());
    bOut.setHeight(bIn.getHeight());
    for (i=0;i<bIn.getWidth();i++){
      for (j=0;j<bIn.getHeight();j++){
        dx.R=bIn(i+1,j).R-bIn(i,j).R;
        dx.G=bIn(i+1,j).G-bIn(i,j).G;
        dx.B=bIn(i+1,j).B-bIn(i,j).B;
        dy.R=bIn(i,j+1).R-bIn(i,j).R;
        dy.G=bIn(i,j+1).G-bIn(i,j).G;
        dy.B=bIn(i,j+1).B-bIn(i,j).B;
        bOut(i,j).R=sqrt(dx.R*dx.R+dy.R*dy.R)>f?255:0;
        bOut(i,j).G=sqrt(dx.G*dx.G+dy.G*dy.G)>f?255:0;
        bOut(i,j).B=sqrt(dx.B*dx.B+dy.B*dy.B)>f?255:0;
      }
    }
    bOut.saveFile(argv[2]);
  }
}
